#include <avr/io.h>

#define PIN_PWM 3   /* PWM出力ピン（OC2B）  */

void setup() {
  unsigned int counter_top_val = 31;
      // PWM周波数 = CPUクロック（16MHz）/ (counter_top_val + 1)
      // counter_top_valは0～255
      // 例: 16MHz / (31 + 1) = 500kHz

  pinMode(PIN_PWM, OUTPUT);

  // CS2 = 0x1, WGM2 = 0x7, COM2A = 0x2
  TCCR2A = (1 << COM2B1) | (0 << COM2B0) | (1 << WGM21) | (1 << WGM20);
  TCCR2B = (1 << WGM22) | (1 << CS20);

  OCR2A = counter_top_val;
  OCR2B = counter_top_val >> 1; // デューティ比 OCR2A / 2 : 50%
}

void loop() {
}